clc;
clear;
%%
subplot(2,1,1);
fid = fopen('loss.out','r');

inum = 0;
irow = 0;

while ~feof(fid)
    str = fgetl(fid);
    if strcmp(str(1:6),' Range')
        inum = inum + 1;
    else
        irow = irow + 1;
    end
end
irow = irow / inum;
frewind(fid);

x = zeros(inum,1);
y = zeros(irow,1);
d = zeros(irow,inum);

inum = 0;

while ~feof(fid)
    str = fgetl(fid);
    if strcmp(str(1:6),' Range')
        inum = inum + 1;
        irow = 0;
        [str1 str2 str3] = strread(str,'%s %s %s',1,'delimiter',' '); 
        t1 = cell2mat(str3);
        x(inum) = str2num(t1);
    else
        irow = irow + 1;
        [str1 str2] = strread(str,'%s %s',1,'delimiter',' '); 
        t1 = cell2mat(str1); t2 = cell2mat(str2);
        if inum < 2
            y(irow) = str2num(t1);
        end
        d(irow,inum) = str2num(t2);
    end
end
fclose( fid );
x = x / 1000;
tej = flipud( colormap( jet ) );
imagesc(x,y,d);
xlabel('Range / km','fontsize',12);
ylabel('Depth / m','fontsize',12);
colorbar;
colormap(tej);
caxis([50 100]);
set(gca,'fontsize',12);
%%
subplot(2,1,2);
plot(x,d(90,:),'linewidth',2);
hold on;
plot(x,d(240,:),'r-','linewidth',2);
axis ij;
xlabel('Range / km','fontsize',12);
ylabel('Propagation Loss / dB','fontsize',12);
set(gca,'fontsize',12);
ylim([50 90]);
legend('90 m depth','240 m depth')
%%
set(gcf,'units','normalized','position',[0.1,0.1,0.5,0.8]);