
    module gridmod
    
    real(kind=8)    pi
    parameter ( pi = 3.1415926535897932d0 )
    
    ! computation grid (provided according to the need)
    real(kind=8)    rmax, dr, zmax, dz
    parameter( rmax = 20000.d0, dr = 5.d0, zmax = 240.d0, dz = 1.d0 )
    
    integer(kind=4) nstep, n
    parameter( nstep = int(rmax/dr), n = int(zmax/dz) )
    
    ! eye   : imaginary unit
    complex(kind=8) eye
    parameter( eye = dcmplx(0.0,1.0) ) 
    
    ! source (or initial) field
    complex(kind=8) uinit(n)
    
    ! array to restore the intermediate results
    real(kind=8)    pbasic(n,nstep), pguess(n,nstep), ptrue(n,nstep)
    complex(kind=8) ylrws, xlrws, cnbm, g0(0:2*nstep), ubasic(n,0:nstep)
    
    complex(kind=8) cnbm1  
    complex(kind=8) cnbm1d  
    complex(kind=8) cnbm1b  
    
    real(kind=8)    pobs(n,nstep)
    real(kind=8)    pobsd(n,nstep)
    real(kind=8)    pobsb(n,nstep)
    
    complex(kind=8) uobs(n,0:nstep), ymw(n), c(n,3), cr(n,nstep), ur(n,nstep), urm(n,nstep), gam(n-1,nstep), bet(n-1,nstep)
    complex(kind=8) uobsd(n,0:nstep), ymwd(n), cd(n,3), crd(n,nstep), urd(n,nstep), urmd(n,nstep), gamd(n-1,nstep), betd(n-1,nstep)
    complex(kind=8) uobsb(n,0:nstep), ymwb(n), cb0(n,3), crb(n,nstep), urb(n,nstep), urmb(n,nstep), gamb(n-1,nstep), betb(n-1,nstep)
    
    ! regularization parameter
    real(kind=8)    gamma
    !parameter ( gamma = 0.d0 )
    
    end module gridmod