!   adjoint codes of pestep
    
    SUBROUTINE PESTEP_B(cwater, cwaterb)
    
    USE GRIDMOD
  
    implicit integer(kind=4) (i-n) 
    implicit real(kind=8)    (a-h, o-z)  
    
    ! control variables
    REAL(kind=8) :: cwater(n)
    REAL(kind=8) :: cwaterb(n)

    ! common variables
    COMMON /source/ frq, zs, zr, c0, xko
    COMMON /layer1/ rho1, alpha1
    COMMON /layer2/ zb, cb, rho2, alpha2

    ! local variables
  
    COMPLEX(kind=8) :: xx1, xx2, xn1, miu2, beta, theta  
    COMPLEX(kind=8) :: xn1b
    COMPLEX(kind=8) :: a(n), xx1m(n), g1(0:nstep), g2(0:nstep)
    COMPLEX(kind=8) :: ab(n), xx1mb(n)
  
    REAL(kind=8) :: xn
    REAL(kind=8) :: xnb

    REAL(kind=8) :: tpm
    REAL(kind=8) :: tpmb

    COMPLEX(kind=8) :: result1
    COMPLEX(kind=8) :: result1b
    
    COMPLEX(kind=8) :: tempb1, tempb0, tempb
  
    betb = (0.d0,0.d0)
    urb = (0.d0,0.d0)
    urmb = (0.d0,0.d0)
    ymwb = (0.d0,0.d0)
    crb = (0.d0,0.d0)
    gamb = (0.d0,0.d0)
    cb0 = (0.d0,0.d0)
    uobsb = (0.d0,0.d0)
 
    DO istep=nstep,1,-1
   
        DO i=n,1,-1
            result1 = dCONJG(uobs(i,istep))
            tpm = uobs(i,istep) * result1
            if (tpm .le. 0.d0) then
                pobsb(i,istep) = 0.d0
            else
                tpmb = -(10.0*pobsb(i,istep)/(tpm*dLOG(10.d0)))
                pobsb(i,istep) = 0.d0
            end if
            uobsb(i,istep) = uobsb(i,istep) + dconjg(result1)*tpmb
            result1b = dconjg(uobs(i,istep))*tpmb
            tpmb = 0.d0
            uobsb(i,istep) = uobsb(i,istep) + dconjg(result1b)
            result1b = (0.d0,0.d0)
        END DO
    
        urmb(:,istep) = urmb(:,istep) + uobsb(:,istep)
        uobsb(:,istep) = (0.d0,0.d0)
    
        cnbm1b = 0.d0
        urmb(n-1,istep) = urmb(n-1,istep) + urmb(n,istep)/dconjg(1.0-cnbm)
        cnbm1b = cnbm1b + urmb(n,istep)/dconjg(xlrws)
        urmb(n,istep) = (0.d0,0.d0)
    
        DO j=1,n-2,1
            urb(j,istep) = urb(j,istep) + urmb(j,istep)
            gamb(j+1,istep) = gamb(j+1,istep) - dconjg(urm(j+1,istep))*urmb(j,istep)
            urmb(j+1,istep) = urmb(j+1,istep) - dconjg(gam(j+1,istep))*urmb(j,istep)
            urmb(j,istep) = (0.d0,0.d0)
        END DO
        
        urb(:,istep) = urb(:,istep) + urmb(:,istep)
        urmb(:,istep) = (0.d0,0.d0)
    
        DO j=n-1,2,-1
        
            tempb0 = urb(j,istep)/dconjg(bet(j,istep))
            crb(j,istep) = crb(j,istep) + tempb0
            cb0(j,1) = cb0(j,1) - dconjg(ur(j-1,istep))*tempb0
            urb(j-1,istep) = urb(j-1,istep) - dconjg(c(j,1))*tempb0      
            betb(j,istep) = betb(j,istep) - dconjg((cr(j,istep)-c(j,1)*ur(j-1,istep)))*tempb0/dconjg(bet(j,istep))
            urb(j,istep) = (0.d0,0.d0)
      
            cb0(j,2) = cb0(j,2) + betb(j,istep)
            cb0(j,1) = cb0(j,1) - dconjg(gam(j,istep))*betb(j,istep)
            gamb(j,istep) = gamb(j,istep) - dconjg(c(j,1))*betb(j,istep)
            betb(j,istep) = (0.d0,0.d0)
      
            tempb1 = gamb(j,istep)/dconjg(bet(j-1,istep))
            cb0(j-1,3) = cb0(j-1,3) + tempb1
            betb(j-1,istep) = betb(j-1,istep) - dconjg(c(j-1,3))*tempb1/dconjg(bet(j-1,istep))
            gamb(j,istep) = (0.d0,0.d0)
   
        END DO
    
        tempb = urb(1, istep)/dconjg(bet(1, istep))
        crb(1, istep) = crb(1, istep) + tempb
        betb(1, istep) = betb(1, istep) - dconjg(cr(1, istep))*tempb/dconjg(bet(1, istep))
        urb(1, istep) = (0.d0,0.d0)
        cb0(1, 2) = cb0(1, 2) + betb(1, istep)
        betb(1, istep) = (0.d0,0.d0)
    
        cnbm1b = cnbm1b - crb(n-1, istep)
        
        cnbm1b = dconjg(cnbm*xlrws)*cnbm1b/dconjg(1.0-cnbm)
        DO i=istep,1,-1
            j = istep - i
            uobsb(n, j) = uobsb(n, j) + dconjg(g0(i))*cnbm1b
        END DO
        
        cnbm1b = (0.d0,0.d0)
   
        DO i=n-1,2,-1
            uobsb(i, istep-1) = uobsb(i, istep-1) + dconjg(ymw(i))*crb(i, istep)
            ymwb(i) = ymwb(i) + dconjg(uobs(i, istep-1))*crb(i, istep)
            uobsb(i-1, istep-1) = uobsb(i-1, istep-1) + dconjg(ylrws)*crb(i, istep)
            uobsb(i+1, istep-1) = uobsb(i+1, istep-1) + dconjg(ylrws)*crb(i, istep)
            crb(i, istep) = 0.d0
        END DO
   
        uobsb(1, istep-1) = uobsb(1, istep-1) + dconjg(ymw(1))*crb(1, istep)
        ymwb(1) = ymwb(1) + dconjg(uobs(1, istep-1))*crb(1, istep)
        uobsb(2, istep-1) = uobsb(2, istep-1) + dconjg(ylrws)*crb(1, istep)
        crb(1, istep) = 0.d0
        
    END DO
  
    xx1mb = (0.d0,0.d0)
 
    DO i=n-1,1,-1
        ymwb(i) = ymwb(i) - cb0(i,2)
        cb0(i, 2) = 0.d0
        xx1mb(i) = xx1mb(i) + dr*ymwb(i)
        ymwb(i) = 0.d0
    END DO
    
    cb0 = (0.d0,0.d0)
    ymwb = (0.d0,0.d0)
  
    ab = (0.d0,0.d0)
  
    DO i=n,1,-1
        ab(i) = ab(i) + 0.5*xx1mb(i)
        xx1mb(i) = 0.d0
        xn1b = dconjg(eye*0.5*xko)*ab(i)
        ab(i) = (0.d0,0.d0)
        xn = c0/cwater(i)
        xnb = dconjg(dcmplx(2.*xn, alpha1*2.*xn/27.287527))*xn1b
        !xnb = (alpha1*CMPLX(0.0,1.0)*2*xn/27.287527+CMPLX(1.0, 0.0)*2*xn)*xn1b
        xn1b = (0.d0,0.d0)
        cwaterb(i) = cwaterb(i) - c0*xnb/cwater(i)**2
        xnb = 0.d0
    END DO

    return
    
    END SUBROUTINE PESTEP_B
