!   tagent-linear codes of pestep
    
    SUBROUTINE PESTEP_D(cwater, cwaterd)
  
    USE GRIDMOD
  
    implicit integer(kind=4) (i-n) 
    implicit real(kind=8)    (a-h, o-z)    

    ! control variables
    REAL(kind=8) :: cwater(n)
    REAL(kind=8) :: cwaterd(n)

    ! common variables
    COMMON /source/ frq, zs, zr, c0, xko
    COMMON /layer1/ rho1, alpha1
    COMMON /layer2/ zb, cb, rho2, alpha2

    ! local variables
  
    COMPLEX(kind=8) :: xx1, xx2, xn1, miu2, beta, theta  
    COMPLEX(kind=8) :: xn1d
    COMPLEX(kind=8) :: a(n), xx1m(n), g1(0:nstep), g2(0:nstep)
    COMPLEX(kind=8) :: ad(n), xx1md(n)
  
    REAL(kind=8) :: xn
    REAL(kind=8) :: xnd

    REAL(kind=8) :: tpm
    REAL(kind=8) :: tpmd

    COMPLEX(kind=8) :: result1
    COMPLEX(kind=8) :: result1d

!   layer 1
    
    xx1md = (0.d0,0.d0)
    ad = (0.d0,0.d0)
  
    DO i=1,n
        xnd = -(c0*cwaterd(i)/cwater(i)**2)
        xn = c0/cwater(i)
        xn1d = dCMPLX(xnd*xn + xn*xnd, alpha1*(xnd*xn+xn*xnd)/27.287527)
        ad(i) = 0.5*eye*xko*xn1d
        xx1md(i) = 0.5*ad(i)
    END DO
  
    ymwd = (0.d0,0.d0)
    cd = (0.d0,0.d0)

    DO i=1,n-1
        ymwd(i) = dr*xx1md(i)
        cd(i, 2) = -ymwd(i)
    END DO
    
!   interface (lower boundary)
  
    betd = (0.d0,0.d0)
    urd = (0.d0,0.d0)
    crd = (0.d0,0.d0)
    gamd = (0.d0,0.d0)
  
    DO istep=1,nstep

        crd(1, istep) = uobsd(1, istep-1)*ymw(1) + uobs(1, istep-1)*ymwd(1) + ylrws*uobsd(2, istep-1)
  
        DO i=2,n-1
            crd(i, istep) = uobsd(i, istep-1)*ymw(i) + uobs(i, istep-1)*ymwd(i) + ylrws*(uobsd(i-1, istep-1)+uobsd(i+1, istep-1))
        END DO

        cnbm1d = (0.d0,0.d0)
    
        DO i=1,istep
            j = istep - i
            cnbm1d = cnbm1d + g0(i)*uobsd(n, j)
        END DO
        cnbm1d = cnbm*xlrws*cnbm1d/(1.0-cnbm)
    
        crd(n-1, istep) = crd(n-1, istep) - cnbm1d
  
        betd(1, istep) = cd(1, 2)
        urd(1, istep) = (crd(1, istep)*bet(1, istep)-cr(1, istep)*betd(1, istep))/bet(1, istep)**2
    
        DO j=2,n-1
            gamd(j, istep) = (cd(j-1, 3)*bet(j-1, istep)-c(j-1, 3)*betd(j-1, istep))/bet(j-1, istep)**2
            betd(j, istep) = cd(j, 2) - cd(j, 1)*gam(j, istep) - c(j, 1)*gamd(j, istep)
            urd(j, istep) = ((crd(j,istep)-cd(j,1)*ur(j-1,istep)-c(j,1)*urd(j-1,istep))*bet(j,istep)-(cr(j,istep)-c(j,1)*ur(j-1,istep))*betd(j,istep))/bet(j,istep)**2
        END DO
        urmd(:,istep) = urd(:,istep)
  
        DO j=n-2,1,-1
            urmd(j, istep) = urd(j, istep) - gamd(j+1, istep)*urm(j+1, istep) - gam(j+1, istep)*urmd(j+1, istep)
        END DO
    
        urmd(n, istep) = urmd(n-1, istep)/(1.0-cnbm) + cnbm1d/xlrws
   
        uobsd(:, istep) = urmd(:, istep)
 
        DO i=1,n
            result1 = dCONJG(uobs(i,istep))
            result1d = dCONJG(uobsd(i,istep))
            tpm = uobs(i,istep) * result1
            tpmd = uobsd(i,istep)*result1 + uobs(i,istep)*result1d
            if (tpm .le. 0.d0) then
                pobsd(i,istep) = 0.d0
            else
                pobsd(i, istep) = -(10.0*tpmd/(tpm*dLOG(10.d0)))
            end if           
        END DO
     
    END DO

    RETURN

    END SUBROUTINE PESTEP_D