!   Gaussian source
    
	subroutine sfield( xko, zs, n, dz, U )

    implicit integer(kind=4) (i-n) 
    implicit real(kind=8)    (a-h, o-z) 
    
	complex(kind=8)   u(n)

	gw = 2.d0 / xko		! Gaussian width
	ga = dsqrt(gw) / gw	! Gaussian amplitude
	     
	do i=1, n
		zm = i * dz
		pr = gauss( ga, zm, zs, gw ) - gauss( ga, -zm, zs, gw )
		u(i) = dcmplx( pr, 0.d0 )
    end do
	      
	return

    end subroutine sfield

!   ******************************

    function gauss( ga, z, gd, gw )

    implicit integer(kind=4) (i-n) 
    implicit real(kind=8)    (a-h, o-z) 
    
	v = (z-gd) / gw
	v = -(v*v)	
	gauss = ga * dexp(v)

	return

    end function gauss